# selenium.webdriver.common.options

Classes

`ArgOptions`() |
`BaseOptions`() | Base class for individual browser options.
`PageLoadStrategy`(value[, names, module, ...]) | Enum of possible page load strategies.

class selenium.webdriver.common.options.PageLoadStrategy(value, names=<not given>, *values, module=None, qualname=None, type=None, start=1, boundary=None)

  Enum of possible page load strategies.

  Selenium support following strategies:

    - normal (default) - waits for all resources to download

    - eager - DOM access is ready, but other resources like images may still be loading

    - none - does not block WebDriver at all

  Docs: https://www.selenium.dev/documentation/webdriver/drivers/options/#pageloadstrategy.

  normal = 'normal'
  eager = 'eager'
  none = 'none'
  encode(encoding='utf-8', errors='strict')

    Encode the string using the codec registered for encoding.

    encoding

      The encoding in which to encode the string.

    errors

      The error handling scheme to use for encoding errors. The default is ‘strict’ meaning that encoding errors raise a UnicodeEncodeError. Other possible values are ‘ignore’, ‘replace’ and ‘xmlcharrefreplace’ as well as any other name registered with codecs.register_error that can handle UnicodeEncodeErrors.

  replace(old, new, count=-1, /)

    Return a copy with all occurrences of substring old replaced by new.

    > count

    >   Maximum number of occurrences to replace. -1 (the default value) means replace all occurrences.

    If the optional argument count is given, only the first count occurrences are replaced.

  split(sep=None, maxsplit=-1)

    Return a list of the substrings in the string, using sep as the separator string.

    > sep

    >   The separator used to split the string.

    >   When set to None (the default value), will split on any whitespace character (including n r t f and spaces) and will discard empty strings from the result.

    > maxsplit

    >   Maximum number of splits. -1 (the default value) means no limit.

    Splitting starts at the front of the string and works to the end.

    Note, str.split() is mainly useful for data that has been intentionally delimited. With natural text that includes punctuation, consider using the regular expression module.

  rsplit(sep=None, maxsplit=-1)

    Return a list of the substrings in the string, using sep as the separator string.

    > sep

    >   The separator used to split the string.

    >   When set to None (the default value), will split on any whitespace character (including n r t f and spaces) and will discard empty strings from the result.

    > maxsplit

    >   Maximum number of splits. -1 (the default value) means no limit.

    Splitting starts at the end of the string and works to the front.

  join(iterable, /)

    Concatenate any number of strings.

    The string whose method is called is inserted in between each given string. The result is returned as a new string.

    Example: ‘.’.join([‘ab’, ‘pq’, ‘rs’]) -> ‘ab.pq.rs’

  capitalize()

    Return a capitalized version of the string.

    More specifically, make the first character have upper case and the rest lower case.

  casefold()

    Return a version of the string suitable for caseless comparisons.

  title()

    Return a version of the string where each word is titlecased.

    More specifically, words start with uppercased characters and all remaining cased characters have lower case.

  center(width, fillchar=' ', /)

    Return a centered string of length width.

    Padding is done using the specified fill character (default is a space).

  count(sub[, start[, end]]) → int

    Return the number of non-overlapping occurrences of substring sub in string S[start:end]. Optional arguments start and end are interpreted as in slice notation.

  expandtabs(tabsize=8)

    Return a copy where all tab characters are expanded using spaces.

    If tabsize is not given, a tab size of 8 characters is assumed.

  find(sub[, start[, end]]) → int

    Return the lowest index in S where substring sub is found, such that sub is contained within S[start:end]. Optional arguments start and end are interpreted as in slice notation.

    Return -1 on failure.

  partition(sep, /)

    Partition the string into three parts using the given separator.

    This will search for the separator in the string. If the separator is found, returns a 3-tuple containing the part before the separator, the separator itself, and the part after it.

    If the separator is not found, returns a 3-tuple containing the original string and two empty strings.

  index(sub[, start[, end]]) → int

    Return the lowest index in S where substring sub is found, such that sub is contained within S[start:end]. Optional arguments start and end are interpreted as in slice notation.

    Raises ValueError when the substring is not found.

  ljust(width, fillchar=' ', /)

    Return a left-justified string of length width.

    Padding is done using the specified fill character (default is a space).

  lower()

    Return a copy of the string converted to lowercase.

  lstrip(chars=None, /)

    Return a copy of the string with leading whitespace removed.

    If chars is given and not None, remove characters in chars instead.

  rfind(sub[, start[, end]]) → int

    Return the highest index in S where substring sub is found, such that sub is contained within S[start:end]. Optional arguments start and end are interpreted as in slice notation.

    Return -1 on failure.

  rindex(sub[, start[, end]]) → int

    Return the highest index in S where substring sub is found, such that sub is contained within S[start:end]. Optional arguments start and end are interpreted as in slice notation.

    Raises ValueError when the substring is not found.

  rjust(width, fillchar=' ', /)

    Return a right-justified string of length width.

    Padding is done using the specified fill character (default is a space).

  rstrip(chars=None, /)

    Return a copy of the string with trailing whitespace removed.

    If chars is given and not None, remove characters in chars instead.

  rpartition(sep, /)

    Partition the string into three parts using the given separator.

    This will search for the separator in the string, starting at the end. If the separator is found, returns a 3-tuple containing the part before the separator, the separator itself, and the part after it.

    If the separator is not found, returns a 3-tuple containing two empty strings and the original string.

  splitlines(keepends=False)

    Return a list of the lines in the string, breaking at line boundaries.

    Line breaks are not included in the resulting list unless keepends is given and true.

  strip(chars=None, /)

    Return a copy of the string with leading and trailing whitespace removed.

    If chars is given and not None, remove characters in chars instead.

  swapcase()

    Convert uppercase characters to lowercase and lowercase characters to uppercase.

  translate(table, /)

    Replace each character in the string using the given translation table.

    > table

    >   Translation table, which must be a mapping of Unicode ordinals to Unicode ordinals, strings, or None.

    The table must implement lookup/indexing via __getitem__, for instance a dictionary or list. If this operation raises LookupError, the character is left untouched. Characters mapped to None are deleted.

  upper()

    Return a copy of the string converted to uppercase.

  startswith(prefix[, start[, end]]) → bool

    Return True if S starts with the specified prefix, False otherwise. With optional start, test S beginning at that position. With optional end, stop comparing S at that position. prefix can also be a tuple of strings to try.

  endswith(suffix[, start[, end]]) → bool

    Return True if S ends with the specified suffix, False otherwise. With optional start, test S beginning at that position. With optional end, stop comparing S at that position. suffix can also be a tuple of strings to try.

  removeprefix(prefix, /)

    Return a str with the given prefix string removed if present.

    If the string starts with the prefix string, return string[len(prefix):]. Otherwise, return a copy of the original string.

  removesuffix(suffix, /)

    Return a str with the given suffix string removed if present.

    If the string ends with the suffix string and that suffix is not empty, return string[:-len(suffix)]. Otherwise, return a copy of the original string.

  isascii()

    Return True if all characters in the string are ASCII, False otherwise.

    ASCII characters have code points in the range U+0000-U+007F. Empty string is ASCII too.

  islower()

    Return True if the string is a lowercase string, False otherwise.

    A string is lowercase if all cased characters in the string are lowercase and there is at least one cased character in the string.

  isupper()

    Return True if the string is an uppercase string, False otherwise.

    A string is uppercase if all cased characters in the string are uppercase and there is at least one cased character in the string.

  istitle()

    Return True if the string is a title-cased string, False otherwise.

    In a title-cased string, upper- and title-case characters may only follow uncased characters and lowercase characters only cased ones.

  isspace()

    Return True if the string is a whitespace string, False otherwise.

    A string is whitespace if all characters in the string are whitespace and there is at least one character in the string.

  isdecimal()

    Return True if the string is a decimal string, False otherwise.

    A string is a decimal string if all characters in the string are decimal and there is at least one character in the string.

  isdigit()

    Return True if the string is a digit string, False otherwise.

    A string is a digit string if all characters in the string are digits and there is at least one character in the string.

  isnumeric()

    Return True if the string is a numeric string, False otherwise.

    A string is numeric if all characters in the string are numeric and there is at least one character in the string.

  isalpha()

    Return True if the string is an alphabetic string, False otherwise.

    A string is alphabetic if all characters in the string are alphabetic and there is at least one character in the string.

  isalnum()

    Return True if the string is an alpha-numeric string, False otherwise.

    A string is alpha-numeric if all characters in the string are alpha-numeric and there is at least one character in the string.

  isidentifier()

    Return True if the string is a valid Python identifier, False otherwise.

    Call keyword.iskeyword(s) to test whether string s is a reserved identifier, such as “def” or “class”.

  isprintable()

    Return True if the string is printable, False otherwise.

    A string is printable if all of its characters are considered printable in repr() or if it is empty.

  zfill(width, /)

    Pad a numeric string with zeros on the left, to fill a field of the given width.

    The string is never truncated.

  format(*args, **kwargs) → str

    Return a formatted version of S, using substitutions from args and kwargs. The substitutions are identified by braces (‘{’ and ‘}’).

  format_map(mapping) → str

    Return a formatted version of S, using substitutions from mapping. The substitutions are identified by braces (‘{’ and ‘}’).

  static maketrans()

    Return a translation table usable for str.translate().

    If there is only one argument, it must be a dictionary mapping Unicode ordinals (integers) or characters to Unicode ordinals, strings or None. Character keys will be then converted to ordinals. If there are two arguments, they must be strings of equal length, and in the resulting dictionary, each character in x will be mapped to the character at the same position in y. If there is a third argument, it must be a string, whose characters will be mapped to None in the result.

class selenium.webdriver.common.options.BaseOptions

  Base class for individual browser options.

  browser_version

    Gets and Sets the version of the browser.

    ## Usage

    - Get

        - self.browser_version

    - Set

        - self.browser_version = value

    ## Parameters

    value: str

    ## Returns

    - Get

        - str

    - Set

        - None

  platform_name

    Gets and Sets name of the platform.

    ## Usage

    - Get

        - self.platform_name

    - Set

        - self.platform_name = value

    ## Parameters

    value: str

    ## Returns

    - Get

        - str

    - Set

        - None

  accept_insecure_certs

    Gets and Set whether the session accepts insecure certificates.

    ## Usage

    - Get

        - self.accept_insecure_certs

    - Set

        - self.accept_insecure_certs = value

    ## Parameters

    value: bool

    ## Returns

    - Get

        - bool

    - Set

        - None

  strict_file_interactability

    Gets and Sets whether session is about file interactability.

    ## Usage

    - Get

        - self.strict_file_interactability

    - Set

        - self.strict_file_interactability = value

    ## Parameters

    value: bool

    ## Returns

    - Get

        - bool

    - Set

        - None

  set_window_rect

    Gets and Sets window size and position.

    ## Usage

    - Get

        - self.set_window_rect

    - Set

        - self.set_window_rect = value

    ## Parameters

    value: bool

    ## Returns

    - Get

        - bool

    - Set

        - None

  enable_bidi

    Gets and Set whether the session has WebDriverBiDi enabled.

    ## Usage

    - Get

        - self.enable_bidi

    - Set

        - self.enable_bidi = value

    ## Parameters

    value: bool

    ## Returns

    - Get

        - bool

    - Set

        - None

  page_load_strategy

    :Gets and Sets page load strategy, the default is “normal”.

    ## Usage

    - Get

        - self.page_load_strategy

    - Set

        - self.page_load_strategy = value

    ## Parameters

    value: str

    ## Returns

    - Get

        - str

    - Set

        - None

  unhandled_prompt_behavior

    :Gets and Sets unhandled prompt behavior, the default is “dismiss and notify”.

    ## Usage

    - Get

        - self.unhandled_prompt_behavior

    - Set

        - self.unhandled_prompt_behavior = value

    ## Parameters

    value: str

    ## Returns

    - Get

        - str

    - Set

        - None

  timeouts

    :Gets and Sets implicit timeout, pageLoad timeout and script timeout if set (in milliseconds)

    ## Usage

    - Get

        - self.timeouts

    - Set

        - self.timeouts = value

    ## Parameters

    value: dict

    ## Returns

    - Get

        - dict

    - Set

        - None

  proxy

    Sets and Gets Proxy.

    ## Usage

    - Get

        - self.proxy

    - Set

        - self.proxy = value

    ## Parameters

    value: Proxy

    ## Returns

    - Get

        - Proxy

    - Set

        - None

  enable_downloads

    Gets and Sets whether session can download files.

    ## Usage

    - Get

        - self.enable_downloads

    - Set

        - self.enable_downloads = value

    ## Parameters

    value: bool

    ## Returns

    - Get

        - bool

    - Set

        - None

  web_socket_url

    Gets and Sets WebSocket URL.

    ## Usage

    - Get

        - self.web_socket_url

    - Set

        - self.web_socket_url = value

    ## Parameters

    value: bool

    ## Returns

    - Get

        - bool

    - Set

        - None

  property capabilities
  set_capability(name, value) → None

    Sets a capability.

  enable_mobile(android_package: str | None = None, android_activity: str | None = None, device_serial: str | None = None) → None

    Enables mobile browser use for browsers that support it.

    Args:

      android_activity: The name of the android package to start

  abstract to_capabilities()

    Convert options into capabilities dictionary.

  abstract property default_capabilities

    Return minimal capabilities necessary as a dictionary.

  ignore_local_proxy_environment_variables() → None

    By calling this you will ignore HTTP_PROXY and HTTPS_PROXY from being picked up and used.

class selenium.webdriver.common.options.ArgOptions
  property capabilities
  enable_mobile(android_package: str | None = None, android_activity: str | None = None, device_serial: str | None = None) → None

    Enables mobile browser use for browsers that support it.

    Args:

      android_activity: The name of the android package to start

  set_capability(name, value) → None

    Sets a capability.

  browser_version

    Gets and Sets the version of the browser.

    ## Usage

    - Get

        - self.browser_version

    - Set

        - self.browser_version = value

    ## Parameters

    value: str

    ## Returns

    - Get

        - str

    - Set

        - None

  platform_name

    Gets and Sets name of the platform.

    ## Usage

    - Get

        - self.platform_name

    - Set

        - self.platform_name = value

    ## Parameters

    value: str

    ## Returns

    - Get

        - str

    - Set

        - None

  accept_insecure_certs

    Gets and Set whether the session accepts insecure certificates.

    ## Usage

    - Get

        - self.accept_insecure_certs

    - Set

        - self.accept_insecure_certs = value

    ## Parameters

    value: bool

    ## Returns

    - Get

        - bool

    - Set

        - None

  strict_file_interactability

    Gets and Sets whether session is about file interactability.

    ## Usage

    - Get

        - self.strict_file_interactability

    - Set

        - self.strict_file_interactability = value

    ## Parameters

    value: bool

    ## Returns

    - Get

        - bool

    - Set

        - None

  set_window_rect

    Gets and Sets window size and position.

    ## Usage

    - Get

        - self.set_window_rect

    - Set

        - self.set_window_rect = value

    ## Parameters

    value: bool

    ## Returns

    - Get

        - bool

    - Set

        - None

  enable_bidi

    Gets and Set whether the session has WebDriverBiDi enabled.

    ## Usage

    - Get

        - self.enable_bidi

    - Set

        - self.enable_bidi = value

    ## Parameters

    value: bool

    ## Returns

    - Get

        - bool

    - Set

        - None

  web_socket_url

    Gets and Sets WebSocket URL.

    ## Usage

    - Get

        - self.web_socket_url

    - Set

        - self.web_socket_url = value

    ## Parameters

    value: bool

    ## Returns

    - Get

        - bool

    - Set

        - None

  page_load_strategy

    :Gets and Sets page load strategy, the default is “normal”.

    ## Usage

    - Get

        - self.page_load_strategy

    - Set

        - self.page_load_strategy = value

    ## Parameters

    value: str

    ## Returns

    - Get

        - str

    - Set

        - None

  unhandled_prompt_behavior

    :Gets and Sets unhandled prompt behavior, the default is “dismiss and notify”.

    ## Usage

    - Get

        - self.unhandled_prompt_behavior

    - Set

        - self.unhandled_prompt_behavior = value

    ## Parameters

    value: str

    ## Returns

    - Get

        - str

    - Set

        - None

  timeouts

    :Gets and Sets implicit timeout, pageLoad timeout and script timeout if set (in milliseconds)

    ## Usage

    - Get

        - self.timeouts

    - Set

        - self.timeouts = value

    ## Parameters

    value: dict

    ## Returns

    - Get

        - dict

    - Set

        - None

  proxy

    Sets and Gets Proxy.

    ## Usage

    - Get

        - self.proxy

    - Set

        - self.proxy = value

    ## Parameters

    value: Proxy

    ## Returns

    - Get

        - Proxy

    - Set

        - None

  enable_downloads

    Gets and Sets whether session can download files.

    ## Usage

    - Get

        - self.enable_downloads

    - Set

        - self.enable_downloads = value

    ## Parameters

    value: bool

    ## Returns

    - Get

        - bool

    - Set

        - None

  BINARY_LOCATION_ERROR = 'Binary Location Must be a String'
  property arguments
    Returns:

      A list of arguments needed for the browser.

  add_argument(argument) → None

    Adds an argument to the list.

    Args:

      - Sets the arguments

  ignore_local_proxy_environment_variables() → None

    By calling this you will ignore HTTP_PROXY and HTTPS_PROXY from being picked up and used.

  to_capabilities()

    Convert options into capabilities dictionary.

  property default_capabilities

    Return minimal capabilities necessary as a dictionary.